require "doorkeepr/rails/engine"
require "doorkeepr/rails/nerve"
require "doorkeepr/rails/config"
require "doorkeepr/rails/manager"
require "doorkeepr/rails/entrance"
require "doorkeepr/rails/responder"
require "nerve/easy"

module Doorkeepr
  class << self
    def config
      @config ||= Doorkeepr::Rails::Config.new
    end

    def entrance entrance
      config.entrance = entrance
    end

    def customer customer
      config.customer=customer
    end

    def application application
      config.application=application
    end

    def function function
      config.function=function
    end

    alias_method :service, :function
  end
  module Rails
    @mount_at = :doorkeepr
    class << self
      attr_accessor :manager, :mount_at
      def default_service
        @default_service ||= ::Nerve::Easy::Service.new(::Doorkeepr.config.to_h)
      end
      def announce service
        manager.announce service
      end
      def config
        manager.config
      end
      def publish
        manager.publish
      end
      def depublish
        manager.depublish
      end
    end
  end
end
